package game.core.gui;

import game.core.gui.component.ControllerToolBar;
import game.core.gui.component.DrawableGLEventListener;
import game.core.gui.component.InformationToolBar;
import game.core.gui.component.OptionToolBar;
import game.core.gui.component.StatusPanel;
import game.engine.GameflowController;

import java.awt.BorderLayout;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.border.Border;

import net.java.games.jogl.GLCanvas;
import net.java.games.jogl.GLCapabilities;
import net.java.games.jogl.GLDrawableFactory;


public class DescentGamePanel extends ImagePanel {

	private static DescentGamePanel instance = null;

	public static final String PANEL_ID = "descentGamePanel";

	public static final String ICON_ID = "game_background";

	public GLCanvas glCanvas = null;

	private Border border = BorderFactory.createLoweredBevelBorder();

	private DescentGamePanel(String iconName) {
		super(iconName);
		this.createPanel();
	}

	public void createPanel() {
		this.setLayout(new BorderLayout());

		this.add(InformationToolBar.getInstance(), BorderLayout.NORTH);
		this.add(ControllerToolBar.getInstance(), BorderLayout.EAST);
		this.add(OptionToolBar.getInstance(), BorderLayout.WEST);
		this.add(StatusPanel.getInstance(), BorderLayout.SOUTH);

		JPanel panel_canvas = new JPanel();
		panel_canvas.setLayout(new BorderLayout());

		GLCapabilities glCaps = new GLCapabilities();
		glCanvas = GLDrawableFactory.getFactory().createGLCanvas(glCaps);

		GameflowController.getInstance();
		DrawableGLEventListener glEventListener = new DrawableGLEventListener();

		glCanvas.addKeyListener(glEventListener);
		glCanvas.addMouseListener(glEventListener);
		glCanvas.addGLEventListener(glEventListener);
		glEventListener.setGlc(glCanvas);

		panel_canvas.add(glCanvas, BorderLayout.CENTER);
		panel_canvas.setBorder(border);

		this.add(panel_canvas, BorderLayout.CENTER);
	}

	public static DescentGamePanel getInstance() {
		if (instance == null) {
			instance = new DescentGamePanel(DescentGamePanel.ICON_ID);
		}

		return instance;
	}
}
