package game.core.gui;

import game.engine.util.IconFactory;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.Insets;

import javax.swing.ImageIcon;
import javax.swing.JButton;

public class ImageButton extends JButton{

	private ImageIcon icon = null;
	
	private IconFactory iconFactory = IconFactory.getFactory();

	private String iconName = "button";
	
	public ImageButton(String iconName){
		super();
		this.iconName = iconName;
		this.createIcon();
	}
	
	private void createIcon() {
		icon = iconFactory.getIcon(this.iconName);
	}
	
	public void paintComponent(Graphics g){
		super.paintComponent(g);
		
		Insets insets = this.getInsets();
		icon.paintIcon(this, g, insets.left, insets.top);
		
	}
	
}
