package game.core.gui;

import game.engine.util.IconFactory;

import java.awt.BorderLayout;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Insets;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class ImagePanel extends JPanel{

	private IconFactory imageFactory = IconFactory.getFactory();

	public static final String PANEL_ID = "mainpanel";

	private String iconName = null;
	
	private ImageIcon icon = null;
	
	public ImagePanel(String iconName){
		this.iconName = iconName;
		this.createIcon();
	}

	private void createIcon() {
		icon = imageFactory.getIcon(this.iconName);

		Image scaled = icon.getImage()
				.getScaledInstance(
						MainFrame.getInstance().getMainFrameWidth(),
						MainFrame.getInstance().getMainFrameHeight(),
						Image.SCALE_SMOOTH);

		icon.setImage(scaled);
	}
	
	public void paintComponent(Graphics g){
		super.paintComponent(g);
		
		Insets insets = this.getInsets();
		icon.paintIcon(this, g, insets.left, insets.top);
	}
}
