package game.core.gui;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.Border;

public class LoadGamePanel extends ImagePanel{

	private static LoadGamePanel instance = null;
	
	public static final String PANEL_ID = "LoadPanel";
	
	public static final String ICON_ID = "load_game";
	
	private int width = MainFrame.getInstance().getMainFrameWidth();

	private int height = MainFrame.getInstance().getMainFrameHeight();
	
	private Border border = BorderFactory.createRaisedBevelBorder();
	
	private Border loweredBorder = BorderFactory.createLoweredBevelBorder();
	
	private JButton load_Button = null;
	
	private JButton cancel_Button = null;
	
	private LoadGamePanel(String name){
		super(name);
		this.createPanel();
	}
	
	private void createPanel(){
		this.setLayout(null);
		
		this.add(this.createLoadGamePanel());
	}
	
	private JPanel createLoadGamePanel(){
		JPanel loadGamePanel = new JPanel();
		
		loadGamePanel.setBounds(this.width/2 - 100, 20, this.width/2 + 30, this.height/2);
		loadGamePanel.setOpaque(false);
		
		JList profilList = new JList();
		profilList.setBounds(10, 10, 300,300);
		profilList.setOpaque(false);
		profilList.setBorder(loweredBorder);
		
		load_Button = new ImageButton("load_game_button");
		load_Button.setBounds( 10, 350, 120, 30);
		load_Button.setBorder(border);
		load_Button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				MainFrame.getInstance().CARD_LAYOUT.show(MainFrame
						.getInstance().CONTENT_PANEL, LoadingPanel.PANEL_ID);
			}
		});

		cancel_Button = new ImageButton("cancel_button");
		cancel_Button.setBounds(150, 350, 120,
				30);
		cancel_Button.setBorder(border);
		cancel_Button.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent arg0) {
				MainFrame.getInstance().CARD_LAYOUT.show(MainFrame
						.getInstance().CONTENT_PANEL, MainPanel.PANEL_ID);
			}

		});

		
		loadGamePanel.setLayout(null);
		//loadGamePanel.add(profilList);
		//loadGamePanel.add(load_Button);
		//loadGamePanel.add(cancel_Button);

		return loadGamePanel;
	}
	
	
	
	public static LoadGamePanel getInstance(){
		if(instance == null){
			instance = new LoadGamePanel(LoadGamePanel.ICON_ID);
		}
		
		return instance;
	}
}
