package game.core.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import game.engine.GameflowController;
import game.engine.geometry.GeometryFactory;
import game.engine.util.IconFactory;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.Border;

public class MainPanel extends ImagePanel {

	private static MainPanel instance = null;

	private IconFactory imageFactory = IconFactory.getFactory();

	private Border border = BorderFactory.createRaisedBevelBorder();

	public static final String PANEL_ID = "mainpanel";

	public static final String ICON_ID = "main_back";

	public JButton new_Button = new JButton();

	public JButton load_Button = new JButton();

	public JButton option_Button = new JButton();

	private MainPanel(String name) {
		super(name);

		this.createPanel();
	}

	private void createPanel() {
		this.setLayout(null);
		int width = MainFrame.getInstance().getMainFrameWidth();
		int height = MainFrame.getInstance().getMainFrameHeight();

		ImageIcon icon = IconFactory.getFactory().getIcon("selected_button");

		new_Button = new ImageButton("new_game_button");
		new_Button.setBounds((int) (width / 2 * 1.3), height / 3, 120, 30);
		new_Button.setBorder(border);
		new_Button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				GameflowController.getInstance().createPlayGround(GeometryFactory.LEVEL_1);
				
				MainFrame.getInstance().CARD_LAYOUT.show(MainFrame
						.getInstance().CONTENT_PANEL, DescentGamePanel.PANEL_ID);
				
				DescentGamePanel.getInstance().glCanvas.requestFocusInWindow();
				
			}
		});

		load_Button = new ImageButton("load_game_button");
		load_Button
				.setBounds((int) (width / 2 * 1.3), height / 3 + 40, 120, 30);
		load_Button.setBorder(border);
		load_Button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				MainFrame.getInstance().CARD_LAYOUT.show(MainFrame
						.getInstance().CONTENT_PANEL, LoadGamePanel.PANEL_ID);
			}
		});

		option_Button = new ImageButton("options_button");
		option_Button.setBounds((int) (width / 2 * 1.3), height / 3 + 80, 120,
				30);
		option_Button.setBorder(border);
		option_Button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				MainFrame.getInstance().CARD_LAYOUT
						.show(MainFrame.getInstance().CONTENT_PANEL,
								DescentGamePanel.PANEL_ID);
			}
		});

		this.add(new_Button);
		//this.add(load_Button);
		//this.add(option_Button);
	}

	public static MainPanel getInstance() {
		if (instance == null) {
			instance = new MainPanel(MainPanel.ICON_ID);
		}

		return instance;
	}

}
