package game.core.gui.component;

import java.awt.event.ActionEvent;
import java.util.Vector;

import game.core.IconProperties;
import game.core.gui.DescentGamePanel;
import game.engine.GameflowController;
import game.engine.Node;
import game.engine.PlayGroundElement;
import game.engine.SelectionController;
import game.engine.creatures.Creature;
import game.engine.creatures.CreatureFactory;
import game.engine.util.IconFactory;

import javax.swing.AbstractAction;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JToolBar;
import javax.swing.border.Border;

public class ControllerToolBar extends JToolBar implements
		UserInputEventGenerator {

	private static ControllerToolBar instance = null;

	private Vector userInputListener = new Vector(5, 5);

	private JButton next_turn_button = null;

	private JButton toggle_hero_button = null;

	private JButton use_ability_button1 = null;

	private JButton use_ability_button2 = null;

	private JButton use_ability_button3 = null;

	private JButton use_ability_button4 = null;

	public int currentHero = 0;

	private ControllerToolBar() {
		this.setOpaque(false);
		this.setFloatable(false);
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

		this.addUserInputEventListener(GameflowController.getInstance());

		this.createOptionToolBar();
	}

	public static ControllerToolBar getInstance() {
		if (instance == null) {
			instance = new ControllerToolBar();
		}

		return instance;
	}

	private void createOptionToolBar() {

		next_turn_button = new JButton(new AbstractAction("", IconFactory
				.getFactory().getIcon("next_turn_action")) {

			public void actionPerformed(ActionEvent arg0) {
				ControllerToolBar optionToolBar = ControllerToolBar
						.getInstance();

				optionToolBar.lock();
				optionToolBar.fireUserInputEvent(new UserInputEvent(
						UserInputEvent.NEXT_TURN));

				DescentGamePanel.getInstance().glCanvas.requestFocusInWindow();
			}
		});
		next_turn_button.setOpaque(false);
		next_turn_button.setToolTipText("next turn");

		toggle_hero_button = new JButton(new AbstractAction("", IconFactory
				.getFactory().getIcon("toggle_heros_action")) {

			public void actionPerformed(ActionEvent arg0) {
				/*ControllerToolBar optionToolBar = ControllerToolBar
						.getInstance();

				GameflowController controller = GameflowController
						.getInstance();
				Vector heroList = controller.heroList;

				int index = SelectionController.getInstance().heroIndex;
				++index;
				index %= 3;

				SelectionController.getInstance().selectHero(
						(Node) heroList.elementAt(index));*/

				DescentGamePanel.getInstance().glCanvas.requestFocusInWindow();
			}
		});

		toggle_hero_button.setOpaque(false);
		toggle_hero_button.setToolTipText("toggle heros");

		use_ability_button1 = new JButton(new AbstractAction("", IconFactory
				.getFactory().getIcon("ability")) {

			public void actionPerformed(ActionEvent arg0) {
				ControllerToolBar optionToolBar = ControllerToolBar
						.getInstance();
				
				SelectionController.getInstance().setSpecialAbility(Creature.ACTION_1);
				DescentGamePanel.getInstance().glCanvas.requestFocusInWindow();
			}
		});

		use_ability_button1.setOpaque(false);
		use_ability_button1.setToolTipText("use special ability");

		use_ability_button2 = new JButton(new AbstractAction("", IconFactory
				.getFactory().getIcon("ability")) {

			public void actionPerformed(ActionEvent arg0) {
				ControllerToolBar optionToolBar = ControllerToolBar
						.getInstance();

				SelectionController.getInstance().setSpecialAbility(Creature.ACTION_2);
				DescentGamePanel.getInstance().glCanvas.requestFocusInWindow();
			}
		});

		use_ability_button2.setOpaque(false);
		use_ability_button2.setToolTipText("use special ability");

		use_ability_button3 = new JButton(new AbstractAction("", IconFactory
				.getFactory().getIcon("ability")) {

			public void actionPerformed(ActionEvent arg0) {
				ControllerToolBar optionToolBar = ControllerToolBar
						.getInstance();

				SelectionController.getInstance().setSpecialAbility(Creature.ACTION_3);
				DescentGamePanel.getInstance().glCanvas.requestFocusInWindow();
			}
		});

		use_ability_button3.setOpaque(false);
		use_ability_button3.setToolTipText("use special ability");

		use_ability_button4 = new JButton(new AbstractAction("", IconFactory
				.getFactory().getIcon("ability")) {

			public void actionPerformed(ActionEvent arg0) {
				ControllerToolBar optionToolBar = ControllerToolBar
						.getInstance();

				SelectionController.getInstance().setSpecialAbility(Creature.ACTION_4);
				DescentGamePanel.getInstance().glCanvas.requestFocusInWindow();
			}
		});

		use_ability_button4.setOpaque(false);
		use_ability_button4.setToolTipText("use special ability");

		
		this.add(toggle_hero_button);
		this.add(Box.createVerticalStrut(30));
		this.add(use_ability_button1);
		this.add(use_ability_button2);
		this.add(use_ability_button3);
		this.add(use_ability_button4);
		this.add(Box.createHorizontalStrut(10));
		this.add(next_turn_button);
	}

	void lock() {
		next_turn_button.setEnabled(false);
		toggle_hero_button.setEnabled(false);
		use_ability_button1.setEnabled(false);
	}

	public void unlock() {
		next_turn_button.setEnabled(true);
		toggle_hero_button.setEnabled(true);
		use_ability_button1.setEnabled(true);
	}
	
	public void enableToolBar(){
		this.use_ability_button1.setEnabled(false);
		this.use_ability_button2.setEnabled(false);
		this.use_ability_button3.setEnabled(false);
		this.use_ability_button4.setEnabled(false);
	}
	
	public void disableToolBar(){
		this.use_ability_button1.setEnabled(true);
		this.use_ability_button2.setEnabled(true);
		this.use_ability_button3.setEnabled(true);
		this.use_ability_button4.setEnabled(true);
	}

	public final void selectionChanged(PlayGroundElement hero) {
		Creature hero_creatureData = CreatureFactory
				.getCreature(hero.creatureInfo);

		use_ability_button1.setIcon(IconFactory.getFactory().getIcon(
				hero_creatureData.actionIcon_1));
		use_ability_button2.setIcon(IconFactory.getFactory().getIcon(
				hero_creatureData.actionIcon_2));
		use_ability_button3.setIcon(IconFactory.getFactory().getIcon(
				hero_creatureData.actionIcon_3));
		use_ability_button4.setIcon(IconFactory.getFactory().getIcon(
				hero_creatureData.actionIcon_4));
		
		use_ability_button1.setToolTipText(hero_creatureData.tool_text_1);
		use_ability_button2.setToolTipText(hero_creatureData.tool_text_2);
		use_ability_button3.setToolTipText(hero_creatureData.tool_text_3);
		use_ability_button4.setToolTipText(hero_creatureData.tool_text_4);
		
		toggle_hero_button.setIcon(IconFactory.getFactory().getIcon(
				hero_creatureData.smallIcon));
	}

	public void addUserInputEventListener(Object object) {
		this.userInputListener.addElement(object);
	}

	public void removeUserInputEventListener(Object object) {
		this.userInputListener.removeElement(object);
	}

	public void fireUserInputEvent(UserInputEvent userInputEvent) {
		for (int i = 0; i < this.userInputListener.size(); i++) {
			UserInputListener userInputListener = (UserInputListener) this.userInputListener
					.elementAt(i);

			userInputListener.executeUserEvent(userInputEvent);
		}
	}

}
