package game.core.gui.component;

import game.core.IconProperties;

import java.awt.event.ActionEvent;
import java.util.Vector;

import javax.swing.AbstractAction;
import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JToolBar;

public class InformationToolBar extends JToolBar implements UserInputEventGenerator {

	private ClassLoader cl = this.getClass().getClassLoader();

	private IconProperties iconProp = IconProperties.getInstance();

	private static InformationToolBar instance = null;

	private Vector userInputListener = new Vector(5, 5);

	JButton next_turn_Button = null;
	
	private InformationToolBar() {
		this.setOpaque(false);
		this.setFloatable(false);
		this.createOptionToolBar();
	}

	public static InformationToolBar getInstance() {
		if (instance == null) {
			instance = new InformationToolBar();
		}

		return instance;
	}

	private void createOptionToolBar() {
		next_turn_Button = new JButton(new AbstractAction("", new ImageIcon(cl
				.getResource(iconProp.getProperty("next_turn")))) {

			public void actionPerformed(ActionEvent arg0) {
				InformationToolBar optionToolBar = InformationToolBar.getInstance();

				optionToolBar.lock();
				optionToolBar.fireUserInputEvent(new UserInputEvent(
						UserInputEvent.NEXT_TURN));
				optionToolBar.unlock();

			}
		});

		//this.add(next_turn_Button);
		this.add(Box.createVerticalStrut(20));
	}

	private void lock() {
		next_turn_Button.setEnabled(false);
	}

	private void unlock() {
		next_turn_Button.setEnabled(true);
		// WorldFrame.glCanvas.requestFocusInWindow();
	}

	public void addUserInputEventListener(Object object) {
		this.userInputListener.addElement(object);
	}

	public void removeUserInputEventListener(Object object) {
		this.userInputListener.removeElement(object);
	}

	public void fireUserInputEvent(UserInputEvent userInputEvent) {
		for (int i = 0; i < this.userInputListener.size(); i++) {
			UserInputListener userInputListener = (UserInputListener) this.userInputListener
					.elementAt(i);

			userInputListener.executeUserEvent(userInputEvent);
		}
	}
}
