package game.core.gui.component;

import game.engine.util.IconFactory;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;

import javax.swing.BorderFactory;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;
import javax.swing.ListModel;
import javax.swing.border.Border;

public class TransparentRenderer extends JLabel implements ListCellRenderer {

	private Border lineBorder = BorderFactory.createLineBorder(Color.ORANGE, 2);
	private Border emptyBorder = BorderFactory.createEmptyBorder(2,2,2,2);
	
	public TransparentRenderer() {
		this.setOpaque(false);
	}

	public Component getListCellRendererComponent(JList list, Object value,
			int index, boolean isSelected, boolean cellHasFocus) {

		TransparentListModel listModel =  (TransparentListModel)list.getModel();
		Object[] object = (Object[])listModel.getElementAt(index);

		this.setText((String)object[0]);
		this.setIcon((ImageIcon)object[1]);
		
		if(isSelected){
			this.setForeground(Color.RED);
		}else{
			this.setForeground(Color.BLACK);
		}
		
		if(cellHasFocus){
			this.setBorder(lineBorder);
		}else{
			this.setBorder(emptyBorder);
		}
		
		return this;
	}

}
