package game.engine;

import java.util.Vector;

import game.engine.creatures.Creature;
import game.engine.spatial.Spatial;

public class PlayGroundElement {
	public int posX = -1;

	public int posY = -1;

	public int posZ = -1;

	public int targetX = -1;

	public int targetY = -1;

	public int targetZ = -1;

	public int geometryFactoryType = -1;

	public int[][] playGroundInfo = null;

	public Spatial element = null;

	public Routemap routeMap = new Routemap(this);

	public Vector monsterList = new Vector();

	public int creatureInfo = -1;

	public int wounds = -1;

	public boolean hasMoved = false;

	public boolean hasAttacked = false;

	public boolean useSpecialAbility = false;

	public int action = -1;

	public Node moveMap = null;

	public Node mark = null;

	public Vector moveMapList = null;

	public PlayGroundElement(int x, int y, int z, int geometryFactoryType) {
		this.posX = x;
		this.posY = y;
		this.posZ = z;
		this.geometryFactoryType = geometryFactoryType;
	}

	public PlayGroundElement(int x, int y, int z, int geometryFactoryType,
			int[][] playGroundInfo) {
		this.posX = x;
		this.posY = y;
		this.posZ = z;
		this.geometryFactoryType = geometryFactoryType;
		this.playGroundInfo = playGroundInfo;
	}

	public PlayGroundElement clone() {
		PlayGroundElement playGroundElement = new PlayGroundElement(this.posX,
				this.posY, this.posZ, this.geometryFactoryType,
				this.playGroundInfo);

		return playGroundElement;
	}
}
