package game.engine.ai;

import game.engine.PlayGround;
import game.engine.spatial.LinearAlgebra4D;

public class PathFinder extends AbstractPathFinder {

	private static PathFinder instance = null;
	
	public int borderX = -1;

	public int borderZ = -1;

	public boolean isDiagolnalAllowed = false;

	private PathFinder() {

	}

	public final static PathFinder createInstance(int[][] data){
		if(instance == null){
			instance = new PathFinder();
			
			instance.data = data;
			instance.rows = data[0].length;
		}
		
		return instance;
	}
	
	public final static PathFinder getInstance(){
		return instance;
	}
	
	@Override
	public final int calculateCost(Node node, Node node2, int i, Object data) {
		return 1;
	}

	@Override
	public final boolean isChildValid(Node parent, Node node, int mode, Object data) {

		int[][] playGround = (int[][]) data;

		int x = node.x;
		int z = node.z;
		int xBorder = playGround[0].length;
		int zBorder = playGround.length;
		
		if(x == this.path_dx && z == this.path_dz){
			return true;
		}
		
		if(x >= xBorder || x <= 0 || z >= zBorder || z <= 0){
			return false;
		}
		
		if (playGround[z][x] != PlayGround.FREE) {
			return false;
		}

		return true;
	}

	@Override
	public final void notifyChild(Node node, Node node2, int i, Object data) {

	}

	@Override
	public final void notifyList(Node node, Node node2, int i, Object data) {

	}

	public static void main(String args[]) {
		int[][] playGround = { { 1, 1, 1, 1, 1, 1,1 },
				{ 1, 0, 1, 1, 1, 1, 1 }, { 1, 1, 0, 0, 1, 1, 1 },
				{ 1, 0, 1, 0, 1, 0, 1 }, { 1, 0, 1, 0, 0, 0, 1 },
				{ 1, 0, 0, 0, 0, 1, 1 }, { 1, 1, 0, 0, 0, 0, 1 } ,{ 1, 1, 1, 1, 1, 1, 1 }};
		
		for(int i = 0 ; i < playGround.length; i++){
			for(int j = 0; j < playGround[i].length; j++){
				System.out.print(playGround[i][j]);
			}
			
			System.out.println();
		}
		
		PathFinder path = new PathFinder();
		path.rows = playGround[0].length;
		path.data = playGround;
		
		if(path.generatePath(1,2,4,4)){
			
			Node temp = path.currentNode;
			
			playGround = new int[7][7];
			
			
			while(temp.parent != null){
				playGround[temp.x][temp.z] = PlayGround.STRUCTURE;
				System.out.println(temp.x + " " + temp.z);
				temp = temp.parent;
			}
		}
		
		for(int i = 0 ; i < playGround.length; i++){
			for(int j = 0; j < playGround[i].length; j++){
				System.out.print(playGround[j][i]);
			}
			
			System.out.println();
		}
	}

}
