package game.engine.creatures;

import game.engine.geometry.GeometryFactory;

public class CreatureFactory {

	public static final Creature getCreature(int geometryFactoryType) {

		if(geometryFactoryType == GeometryFactory.DWARF_RANGED){
			return DwarfRanger.getInstance();
		}
		
		if(geometryFactoryType == GeometryFactory.DWARF_GEODE){
			return DwarfGeode.getInstance();
		}
		
		if(geometryFactoryType == GeometryFactory.DWARF_WORRIOR){
			return DwarfWorrior.getInstance();
		}
		
		if(geometryFactoryType == GeometryFactory.BANE_SPIDER){
			return BaneSpider.getInstance();
		}
		
		if(geometryFactoryType == GeometryFactory.OCTOPUS){
			return Octopus.getInstance();
		}
		
		if(geometryFactoryType == GeometryFactory.GATE){
			return Gate.getInstance();
		}
		
		return null;
	}
}
