package game.engine.geometry;

import game.engine.GameflowEvent;
import game.engine.renderer.Renderer;
import game.engine.spatial.LinearAlgebra4D;
import game.engine.spatial.Transformation;

public class Particle extends Cube {

	public static final int LOCATION_X = 0;

	public static final int LOCATION_Y = 1;

	public static final int LOCATION_Z = 2;

	public static final int SPEED_X = 0;

	public static final int SPEED_Y = 1;

	public static final int SPEED_Z = 2;

	public float lifeTime = 0;

	public float decay = 0;

	public float[] location = { 0.0f, 0.0f, 0.0f, 1 };

	public float[] speed = { 0.0f, 0.0f, 0.0f, 1 };


	public Particle(float[][] vertices, float[][] normals, int[] indices,
			float[][] textCoord) {
		super(vertices, indices, textCoord);
		// this.geometryID = this.toString();
		this.geometryType = GeometryConstants.PARTICLE;
	}

	public Particle(float width, float height, float depth, float textureWidth, float textureHeight) {
		super(width, height, depth,  width, height);
		// this.geometryID = this.toString();
		this.geometryType = GeometryConstants.PARTICLE;
	}

	public float getLocation(int direction) {
		return this.location[direction];
	}

	public float getSpeed(int direction) {
		return this.speed[direction];
	}

	public void setSpeed(int direction, float speed) {
		this.speed[direction] = speed;
	}

	public boolean isAlive() {
		return (this.lifeTime > 0.0f);
	}

	public void kill() {
		this.lifeTime = 0.0f;
	}

	public float getDecay() {
		return decay;
	}

	public void setDecay(float decay) {
		this.decay = decay;
	}

	public float getLifeTime() {
		return lifeTime;
	}

	public void setLifeTime(float lifeTime) {
		this.lifeTime = lifeTime;
	}

}
