package game.engine.geometry;

import game.engine.spatial.LinearAlgebra4D;
import game.engine.spatial.Transformation;

public class PolyCube extends Cylinder {

	public PolyCube(int vertexCount, float diameter, float height, float textureScale_s, float textureScale_t) {
		super(vertexCount, diameter, height, textureScale_s, textureScale_t);
		this.geometryType = GeometryConstants.POLY_CUBE;
	}

	public final void updateNormals() {
		float[] normal = new float[4];

		for (int i = 0; i < this.VERTEX_COUNT; ) {
			LinearAlgebra4D.calculateNormal(this.vertices[3 + i], this.vertices[i],
					this.vertices[1 + i], normal);
			LinearAlgebra4D.normalizeVector(normal, normal);
			
			this.normals[i][0] = normal[0];
			this.normals[i][1] = normal[1];
			this.normals[i][2] = normal[2];
			this.normals[i][3] = normal[3];
			
			this.normals[i + 1][0] = normal[0];
			this.normals[i + 1][1] = normal[1];
			this.normals[i + 1][2] = normal[2];
			this.normals[i + 1][3] = normal[3];
			
			this.normals[i + 2][0] = normal[0];
			this.normals[i + 2][1] = normal[1];
			this.normals[i + 2][2] = normal[2];
			this.normals[i + 2][3] = normal[3];
			
			this.normals[i + 3][0] = normal[0];
			this.normals[i + 3][1] = normal[1];
			this.normals[i + 3][2] = normal[2];
			this.normals[i + 3][3] = normal[3];
		
			this.normals[i + 4][0] = normal[0];
			this.normals[i + 4][1] = normal[1];
			this.normals[i + 4][2] = normal[2];
			this.normals[i + 4][3] = normal[3];
		
			this.normals[i + 5][0] = normal[0];
			this.normals[i + 5][1] = normal[1];
			this.normals[i + 5][2] = normal[2];
			this.normals[i + 5][3] = normal[3];
		
			i += 6;
		}
	}

	public static void main(String args[]) {

		PolyCube cube = new PolyCube(2, 2, 2, 10, 10);

		Transformation t = new Transformation();
		float[] t1 = { 30, 30, 30, 1 };

		t.translate(t1);
		cube.updateTransformationState(t);

		for (int i = 0; i < 4; i++) {
			System.out.println(cube.boundingVolume.center[i]);
		}

		System.out.println(cube.boundingVolume.radius[0]);

	}
}
