package game.engine.geometry;

import game.engine.spatial.LinearAlgebra4D;
import game.engine.spatial.Transformation;

public class SolidDeformedConeArc extends Geometry {

	protected float[] center1 = { 0, 0, 0, 1 };

	protected float[] center2 = null;

	protected int t = 0;

	public SolidDeformedConeArc(float diameter1, float diameter2, float length,
			float alpha, int vertexCount) {
		this.geometryType = GeometryConstants.SOLID_DEFORMED_CONE_ARC;
		this.center2 = new float[4];

		this.center2[0] = this.center1[0];
		this.center2[1] = this.center1[1];
		this.center2[2] = length;
		this.center2[3] = 1;

		float step = (float) (2 * Math.PI) / (vertexCount);

		t = vertexCount;
		vertexCount *= 6;
		vertexCount += 6;
		vertexCount += t * 3 * 2 + 6;

		this.VERTEX_COUNT = vertexCount;
		this.NORMAL_COUNT = vertexCount;
		this.INDEX_COUNT = vertexCount;
		this.TEXTURE_COORD_COUNT = vertexCount;
		this.DIMENSION = 4;
		this.TEXTURE_COORD_DIM = 2;

		float[][] vertices = new float[vertexCount][this.DIMENSION];
		float[][] normals = new float[vertexCount][this.DIMENSION];
		int[] indices = new int[vertexCount];
		float[][] textureCoord = new float[vertexCount][this.TEXTURE_COORD_DIM];

		float x1, y1, x2, y2, x3, y3, x4, y4;
		float angle;

		int count_vertex = 0;
		int count_normal = 0;

		float[] vertex = new float[4];
		float[] normal = new float[4];
		float[] temp = null;

		float textureX = 0.0f, textureY = 0.0f;
		textureX = 1;
		textureY = 1;

		alpha = (float) (2 * Math.PI);

		for (angle = 0.0f; angle < alpha;) {

			x1 = diameter1 * (float) Math.cos(angle);
			y1 = diameter1 * (float) Math.sin(angle);

			x3 = diameter2 * (float) Math.cos(angle);
			y3 = diameter2 * (float) Math.sin(angle);

			angle += step;

			x2 = diameter1 * (float) Math.cos(angle);
			y2 = diameter1 * (float) Math.sin(angle);

			x4 = diameter2 * (float) Math.cos(angle);
			y4 = diameter2 * (float) Math.sin(angle);

			vertex[0] = x1;
			vertex[1] = y1;
			vertex[2] = 0;
			vertex[3] = 1;

			vertices[count_vertex] = vertex.clone();

			textureCoord[count_vertex][0] = textureX;
			textureCoord[count_vertex][1] = 0;

			count_vertex++;

			vertex[0] = x2;
			vertex[1] = y2;
			vertex[2] = 0;
			vertex[3] = 1;

			vertices[count_vertex] = vertex.clone();

			textureCoord[count_vertex][0] = textureX;
			textureCoord[count_vertex][1] = textureY;

			count_vertex++;

			vertex[0] = x3;
			vertex[1] = y3;
			vertex[2] = length;
			vertex[3] = 1;

			vertices[count_vertex] = vertex.clone();

			textureCoord[count_vertex][0] = 0;
			textureCoord[count_vertex][1] = 0;

			count_vertex++;

			vertex[0] = x3;
			vertex[1] = y3;
			vertex[2] = length;
			vertex[3] = 1;

			vertices[count_vertex] = vertex.clone();

			textureCoord[count_vertex][0] = 0;
			textureCoord[count_vertex][1] = 0;

			count_vertex++;

			vertex[0] = x2;
			vertex[1] = y2;
			vertex[2] = 0;
			vertex[3] = 1;

			vertices[count_vertex] = vertex.clone();

			textureCoord[count_vertex][0] = textureY;
			textureCoord[count_vertex][1] = textureY;

			count_vertex++;

			vertex[0] = x4;
			vertex[1] = y4;
			vertex[2] = length;
			vertex[3] = 1;

			vertices[count_vertex] = vertex.clone();

			textureCoord[count_vertex][0] = 0;
			textureCoord[count_vertex][1] = textureY;

			count_vertex++;

		}

		angle = (float) (alpha - step);

		x1 = diameter1 * (float) Math.cos(angle);
		y1 = diameter1 * (float) Math.sin(angle);

		x3 = diameter2 * (float) Math.cos(angle);
		y3 = diameter2 * (float) Math.sin(angle);

		angle = (float) (alpha);

		x2 = diameter1 * (float) Math.cos(angle);
		y2 = diameter1 * (float) Math.sin(angle);

		x4 = diameter2 * (float) Math.cos(angle);
		y4 = diameter2 * (float) Math.sin(angle);

		vertex[0] = x1;
		vertex[1] = y1;
		vertex[2] = 0;
		vertex[3] = 1;

		vertices[count_vertex] = vertex.clone();

		textureCoord[count_vertex][0] = textureX;
		textureCoord[count_vertex][1] = 0;

		count_vertex++;

		vertex[0] = x2;
		vertex[1] = y2;
		vertex[2] = 0;
		vertex[3] = 1;

		vertices[count_vertex] = vertex.clone();

		textureCoord[count_vertex][0] = textureX;
		textureCoord[count_vertex][1] = textureY;

		count_vertex++;

		vertex[0] = x3;
		vertex[1] = y3;
		vertex[2] = length;
		vertex[3] = 1;

		vertices[count_vertex] = vertex.clone();

		textureCoord[count_vertex][0] = 0;
		textureCoord[count_vertex][1] = 0;

		count_vertex++;

		vertex[0] = x3;
		vertex[1] = y3;
		vertex[2] = length;
		vertex[3] = 1;

		vertices[count_vertex] = vertex.clone();

		textureCoord[count_vertex][0] = 0;
		textureCoord[count_vertex][1] = 0;

		count_vertex++;

		vertex[0] = x2;
		vertex[1] = y2;
		vertex[2] = 0;
		vertex[3] = 1;

		vertices[count_vertex] = vertex.clone();

		textureCoord[count_vertex][0] = textureY;
		textureCoord[count_vertex][1] = textureY;

		count_vertex++;

		vertex[0] = x4;
		vertex[1] = y4;
		vertex[2] = length;
		vertex[3] = 1;

		vertices[count_vertex] = vertex.clone();

		textureCoord[count_vertex][0] = 0;
		textureCoord[count_vertex][1] = textureY;

		count_vertex++;

		for (angle = 0.0f; angle < alpha;) {

			x1 = diameter1 * (float) Math.cos(angle);
			y1 = diameter1 * (float) Math.sin(angle);

			angle += step;

			x3 = diameter1 * (float) Math.cos(angle);
			y3 = diameter1 * (float) Math.sin(angle);

			vertex[0] = x1;
			vertex[1] = y1;
			vertex[2] = 0;
			vertex[3] = 1;

			vertices[count_vertex] = vertex.clone();

			textureCoord[count_vertex][0] = 0;
			textureCoord[count_vertex][1] = 0;

			count_vertex++;

			vertices[count_vertex] = this.center1.clone();

			textureCoord[count_vertex][0] = textureX;
			textureCoord[count_vertex][1] = 0;

			count_vertex++;

			vertex[0] = x3;
			vertex[1] = y3;
			vertex[2] = 0;
			vertex[3] = 1;

			vertices[count_vertex] = vertex.clone();

			textureCoord[count_vertex][0] = 0;
			textureCoord[count_vertex][1] = textureY;

			count_vertex++;
		}

		angle = alpha - step;

		x1 = diameter1 * (float) Math.cos(angle);
		y1 = diameter1 * (float) Math.sin(angle);

		angle = alpha;

		x3 = diameter1 * (float) Math.cos(angle);
		y3 = diameter1 * (float) Math.sin(angle);

		vertex[0] = x1;
		vertex[1] = y1;
		vertex[2] = 0;
		vertex[3] = 1;

		vertices[count_vertex] = vertex.clone();

		textureCoord[count_vertex][0] = 0;
		textureCoord[count_vertex][1] = 0;

		count_vertex++;

		vertices[count_vertex] = this.center1.clone();

		textureCoord[count_vertex][0] = textureX;
		textureCoord[count_vertex][1] = 0;

		count_vertex++;

		vertex[0] = x3;
		vertex[1] = y3;
		vertex[2] = 0;
		vertex[3] = 1;

		vertices[count_vertex] = vertex.clone();

		textureCoord[count_vertex][0] = 0;
		textureCoord[count_vertex][1] = textureY;

		count_vertex++;

		for (angle = alpha; angle > 0.0f;) {

			x1 = diameter2 * (float) Math.cos(angle);
			y1 = diameter2 * (float) Math.sin(angle);

			angle -= step;

			x3 = diameter2 * (float) Math.cos(angle);
			y3 = diameter2 * (float) Math.sin(angle);

			vertex[0] = x1;
			vertex[1] = y1;
			vertex[2] = length;
			vertex[3] = 1;

			vertices[count_vertex] = vertex.clone();

			textureCoord[count_vertex][0] = 0;
			textureCoord[count_vertex][1] = 0;

			count_vertex++;

			vertices[count_vertex] = this.center2.clone();

			textureCoord[count_vertex][0] = textureX;
			textureCoord[count_vertex][1] = 0;

			count_vertex++;

			vertex[0] = x3;
			vertex[1] = y3;
			vertex[2] = length;
			vertex[3] = 1;

			vertices[count_vertex] = vertex.clone();

			textureCoord[count_vertex][0] = 0;
			textureCoord[count_vertex][1] = textureY;

			count_vertex++;
		}

		angle = step;

		x1 = diameter2 * (float) Math.cos(angle);
		y1 = diameter2 * (float) Math.sin(angle);

		angle = 0.0f;

		x3 = diameter2 * (float) Math.cos(angle);
		y3 = diameter2 * (float) Math.sin(angle);

		vertex[0] = x1;
		vertex[1] = y1;
		vertex[2] = length;
		vertex[3] = 1;

		vertices[count_vertex] = vertex.clone();

		textureCoord[count_vertex][0] = 0;
		textureCoord[count_vertex][1] = 0;

		count_vertex++;

		vertices[count_vertex] = this.center2.clone();

		textureCoord[count_vertex][0] = textureX;
		textureCoord[count_vertex][1] = 0;

		count_vertex++;

		vertex[0] = x3;
		vertex[1] = y3;
		vertex[2] = length;
		vertex[3] = 1;

		vertices[count_vertex] = vertex.clone();

		textureCoord[count_vertex][0] = 0;
		textureCoord[count_vertex][1] = textureY;

		count_vertex++;

		for (int i = 0; i < vertexCount; i++) {
			indices[i] = i;
		}

		this.vertices = vertices;
		this.normals = normals;
		this.indices = indices;
		this.textureCoord = textureCoord;

		Geometry.createVertexBuffer(this);
		Geometry.createNormalBuffer(this);
		Geometry.createVertexBufferData(this);
		this.updateNormals();
		Geometry.createNormalBufferData(this);
		Geometry.createTextureCoordBuffer(this);
		Geometry.createTextureCoordinateBufferData(this);
		Geometry.createDataBuffer(this);
		Geometry.createDataBufferData(this);
		Geometry.updateBoundingSpere(this);
	}

	public final void applyTransformation() {

		Transformation.concateTransformations(this.transformationMatrix,
				this.localTransformation, this.transformationMatrix);

		for (int i = 0; i < VERTEX_COUNT; i++) {
			LinearAlgebra4D.calculateTableVectorProduct(
					this.localTransformation.compositeMatrix, vertices[i],
					vertices[i]);
		}

		LinearAlgebra4D.calculateTableVectorProduct(
				this.localTransformation.compositeMatrix, this.center1,
				this.center1);

		LinearAlgebra4D.calculateTableVectorProduct(
				this.localTransformation.compositeMatrix, this.center2,
				this.center2);

		this.localTransformation.setIdentity();

		this.updateNormals();
		Geometry.updateBoundingSpere(this);
		
		Geometry.updateBuffers(this);
	}

	@Override
	public final  void updateNormals() {
		float[] normal = new float[4];

		int i;

		for (i = 0; i < this.VERTEX_COUNT;) {
			LinearAlgebra4D.calculateVector(this.center1, this.vertices[i],
					normal);
			LinearAlgebra4D.normalizeVector(normal, normal);

			this.normals[i] = normal.clone();

			LinearAlgebra4D.calculateVector(this.center1, this.vertices[i + 1],
					normal);
			LinearAlgebra4D.normalizeVector(normal, normal);

			this.normals[i + 1] = normal.clone();

			LinearAlgebra4D.calculateVector(this.center2, this.vertices[i + 2],
					normal);
			LinearAlgebra4D.normalizeVector(normal, normal);

			this.normals[i + 2] = normal.clone();

			LinearAlgebra4D.calculateVector(this.center2, this.vertices[i + 3],
					normal);
			LinearAlgebra4D.normalizeVector(normal, normal);

			this.normals[i + 3] = normal.clone();

			LinearAlgebra4D.calculateVector(this.center1, this.vertices[i + 4],
					normal);
			LinearAlgebra4D.normalizeVector(normal, normal);

			this.normals[i + 4] = normal.clone();

			LinearAlgebra4D.calculateVector(this.center2, this.vertices[i + 5],
					normal);
			LinearAlgebra4D.normalizeVector(normal, normal);

			this.normals[i + 5] = normal.clone();

			i += 6;
		}
	}

	@Override
	public void executeStaticState() {
		// TODO Auto-generated method stub

	}

	@Override
	public void executeDynamicState() {
		// TODO Auto-generated method stub

	}

	@Override
	public void calculateTexCoord() {
		// TODO Auto-generated method stub
		
	}
	
	public static void main(String args[]) {

		SolidDeformedConeArc cube = new SolidDeformedConeArc(2, 3, 2, (float)Math.PI, 10);

		Transformation t = new Transformation();
		float[] t1 = { 30, 30, 30, 1 };

		t.translate(t1);
		cube.updateTransformationState(t);

		for (int i = 0; i < 4; i++) {
			System.out.println(cube.boundingVolume.center[i]);
		}

		System.out.println(cube.boundingVolume.radius[0]);

	}

}
