package game.engine.geometry;

import game.engine.spatial.LinearAlgebra4D;

public class SolidDeformedPolyCube extends SolidDeformedCylinder{

	public SolidDeformedPolyCube(float diameter1, float diameter2, float height, int vertexCount,
			float textureScale_s, float textureScale_t) {
		super(diameter1, diameter2, height, vertexCount, textureScale_s, textureScale_t);
		this.geometryType = GeometryConstants.SOLID_DEFORMED_POLYCUBE;
	}

	public final void updateNormals() {
		float[] normal = new float[4];

		for (int i = 0; i < this.VERTEX_COUNT; ) {
			LinearAlgebra4D.calculateNormal(this.vertices[2 + i], this.vertices[i],
					this.vertices[1 + i], normal);
			LinearAlgebra4D.normalizeVector(normal, normal);
			
			this.normals[i] = normal.clone();
			this.normals[i + 1] = normal.clone();
			this.normals[i + 2] = normal.clone();

			LinearAlgebra4D.calculateNormal(this.vertices[5 + i], this.vertices[i + 3],
					this.vertices[4 + i], normal);
			LinearAlgebra4D.normalizeVector(normal, normal);
			
			this.normals[i + 3] = normal.clone();
			this.normals[i + 4] = normal.clone();
			this.normals[i + 5] = normal.clone();

			
			i += 6;
		}
	}
}
