package game.engine.renderer;

import game.engine.spatial.LinearAlgebra4D;
import game.engine.spatial.Transformation;

public class Camera {

	public Transformation cameraTransformation = new Transformation();

	public float[] eyePoint = new float[4];

	public float[] lookAtPoint = new float[4];

	public float[] upVector = new float[4];

	public Camera() {
		this.initCamera();
	}

	private final void initCamera() {
		eyePoint[0] = 10;
		eyePoint[1] = 20;
		eyePoint[2] = 5;
		eyePoint[3] = 1;

		lookAtPoint[0] = 10;
		lookAtPoint[1] = 0;
		lookAtPoint[2] = 30;
		lookAtPoint[3] = 1;

		upVector[0] = 0;
		upVector[1] = 1;
		upVector[2] = 0;
		upVector[3] = 1;
		
		
	}

	public final void applyTransformationToEyePoint() {
		
		
		LinearAlgebra4D.calculateTableVectorProduct(
				cameraTransformation.compositeMatrix, eyePoint, eyePoint);
	}

	public final void applyTransformationToLookAtPoint() {
		LinearAlgebra4D.calculateTableVectorProduct(
				cameraTransformation.compositeMatrix, lookAtPoint, lookAtPoint);
	}

	public final void applyTransformationUpVector() {
		LinearAlgebra4D.calculateTableVectorProduct(
				cameraTransformation.compositeMatrix, upVector, upVector);
	}
}
