package game.engine.renderer;

import java.util.Vector;

public class GarbageCollector {

	private static GarbageCollector instance = null;

	private Vector texturObjectIDList = new Vector(30, 10);

	private Renderer renderer = null;

	private GarbageCollector(Renderer renderer) {
		this.renderer = renderer;
	}

	public final static GarbageCollector createInstance(Renderer renderer) {
		if (instance == null) {
			instance = new GarbageCollector(renderer);
		}

		return instance;
	}

	public final static GarbageCollector getInstance() {
		if (instance == null) {
			throw new NullPointerException();
		}

		return instance;
	}

	public final void addTextureObjectID(int textureObjectID) {
		Integer id = new Integer(textureObjectID);

		this.texturObjectIDList.addElement(id);
	}

	public final void deleteTextureObjects() {
		int count = this.texturObjectIDList.size();

		int[] textureObjectIDList = new int[this.texturObjectIDList.size()];

		for (int i = 0; i < count; i++) {
			textureObjectIDList[i] = (Integer) this.texturObjectIDList
					.elementAt(i);
		}

		this.renderer.deleteTextureObjects(textureObjectIDList);
	}
}
