package game.engine.renderer;

import game.engine.SceneGraph;

import java.util.Hashtable;

public class TextureController {

	private static TextureController instance = null;

	private Hashtable idTextureMapper = new Hashtable();

	private Renderer renderer = null;
	
	private TextureController(Renderer renderer) {
		this.renderer = renderer;
	}

	public static final void createTextureController(Renderer renderer){
		if(instance == null){
			instance = new TextureController(renderer);
		}
	}
	
	public static final TextureController getInstance() {

		return instance;
	}

	public final void createTexture(String textureID) {

		Texture texture = (Texture) this.idTextureMapper.get(textureID);
		
		if(texture == null){
			texture = renderer.createTexture(textureID);
			
			this.idTextureMapper.put(textureID, texture);
		}
	}
	
	public final Texture getTexture(String textureID){
		
		return (Texture)this.idTextureMapper.get(textureID);
	}
}
