package game.engine.util;

import java.util.Hashtable;

import game.core.IconProperties;

import javax.swing.ImageIcon;

public class IconFactory {
	
	private static IconFactory instance = new IconFactory();
	
	private IconProperties iconProperties = IconProperties.getInstance();
	
	private ClassLoader cl = this.getClass().getClassLoader();
	
	private Hashtable idIconMapper = new Hashtable();
	
	private IconFactory(){
		
	}
	
	public static IconFactory getFactory(){
		if(instance == null){
			instance = new IconFactory();
		}
		
		return instance;
	}
	
	public final ImageIcon getIcon(String name){
		ImageIcon icon = null;
		
		icon = (ImageIcon)idIconMapper.get(name);
		
		if(icon == null){
			icon = new ImageIcon(cl.getResource(iconProperties.getProperty(name)));
			this.idIconMapper.put(name, icon);
		}
		
		return icon;
	}
}
